/*
 HelloWorld.app
*/

#import <CoreFoundation/CoreFoundation.h>
#import <Foundation/Foundation.h>
#import <UIKit/CDStructures.h>
#import <UIKit/UIPushButton.h>
#import <UIKit/UIThreePartButton.h>
#import <UIKit/UINavigationBar.h>
#import <UIKit/UIWindow.h>
#import <UIKit/UIView-Hierarchy.h>
#import <UIKit/UIHardware.h>
#import <UIKit/UITable.h>
#import <UIKit/UITableCell.h>
#import <UIKit/UITableColumn.h>
#import "HelloWorldApp.h"

@implementation HelloWorldApp

- (int) numberOfRowsInTable: (UITable *)table
{
    return 2;
}

- (UITableCell *) table: (UITable *)table cellForRow: (int)row column: (int)col
{
    return row ? buttonCell : pbCell; 
}

- (UITableCell *) table: (UITable *)table cellForRow: (int)row column: (int)col
				reusing: (BOOL) reusing
{
    return pbCell; 
}

- (void) applicationDidFinishLaunching: (id) unused
{
    UIWindow *window;
    window = [[UIWindow alloc] initWithContentRect: [UIHardware
        fullScreenApplicationContentRect]];
	
    pbCell = [[UIImageAndTextTableCell alloc] init];
    [pbCell setTitle: [NSString stringWithFormat:@"Hello World!"]]; 
	
    UIPushButton *button = [[UIThreePartButton alloc] initWithTitle:
        @"Touch Me"];
    buttonCell = [[UITableCell alloc] init];
    [buttonCell addSubview: button];
    [button sizeToFit];
	
    UITable *table = [[UITable alloc] initWithFrame: CGRectMake(0.0f, 48.0f, 320.0f, 480.0f - 16.0f - 32.0f)];
    UITableColumn *col = [[UITableColumn alloc] initWithTitle: @"HelloApp" identifier: @"hello" width: 320.0f];
	
    [window orderFront: self];
    [window makeKey:self];
    [window _setHidden: NO];	
	
    [table addTableColumn: col]; 
    [table setDataSource: self];
    [table setDelegate: self];
    [table reloadData];
	
    UINavigationBar *nav = [[UINavigationBar alloc] initWithFrame: CGRectMake( 0.0f, 0.0f, 320.0f, 48.0f)];
    [nav showButtonsWithLeftTitle: @"Foo" rightTitle: @"Bar" leftBack: NO];
    [nav setDelegate: self];
	[nav setBarStyle: 0];
	
    struct CGRect rect = [UIHardware fullScreenApplicationContentRect];
    rect.origin.x = rect.origin.y = 0.0f;
    mainView = [[UIView alloc] initWithFrame: rect];
    [mainView addSubview: nav]; 
    [mainView addSubview: table]; 
	
    [window setContentView: mainView];
	
}

- (void) navigationBar: (UINavigationBar *)navBar buttonClicked: (int)button    {
    switch (button) {
        case 0: //Right button
			[self alertEvent: @"Hello Bar"];
            break;
        case 1: //Left button
			[self alertEvent: @"Hello Foo"];
            break;
    }
}

- (void) alertEvent:(NSString*)message    {
    if (message == nil)
    {
       alert = [[UIAlertSheet alloc] initWithTitle: @"Hello"
            buttons: [NSArray arrayWithObjects: @"Yes", @"No", nil]
            defaultButtonIndex: 1
            delegate: self
            context: nil];

        [alert setBodyText: @"Hi there?"];
    }
    else
    {
       alert = [[UIAlertSheet alloc] initWithTitle:  @"Hello" 
            buttons: [NSArray arrayWithObjects: @"OK", nil]
            defaultButtonIndex: 1
            delegate: self
            context: nil];                     

        [alert setBodyText: message];
    }
    [alert popupAlertAnimated:YES];
}

- (void)alertSheet:(UIAlertSheet*)sheet buttonClicked:(int)button   {
	[self setApplicationBadge:@"hello"]; 

/*
    if (button == 1 && [sheet buttonCount] == 2)
    {
  	    UIAlertSheet *helloSheet = [ [ UIAlertSheet alloc ] initWithFrame:
            CGRectMake(0, 240, 320, 240) ];
        [ helloSheet setTitle:@"" ];
        [ helloSheet setBodyText: [ NSString stringWithFormat: 
          @"Hello to iPhone" ] ];
        [ helloSheet addButtonWithTitle:@"OK" ];
        [ helloSheet setDelegate: self ];
        [ helloSheet presentSheetInView: mainView ];

    }
*/
    [alert dismiss];
    [alert release];
}


- (void)dealloc 
{
	[super dealloc];
}


@end

